;; kde2/theme.jl
;; $Id: $

;; Copyright (C) 2000 SATO Satoru <ssato@redhat.com>
;; Licence: GPL v2 or later


(let*

;; ------------------------- frame parts images ------------------------

 (
	;; [top,bottom, left, right] border, 2x2
	(top-images    (make-image "border.png"))
	(bottom-images (make-image "border.png"))
	(left-images   (make-image "border.png"))
	(right-images  (make-image "border.png"))

	;; [top-left,bottom-left, top-right, bottom-right] border, 2x2
	(top-left-images     (make-image "border.png"))
	(bottom-left-images  (make-image "border.png"))
	(top-right-images    (make-image "border.png"))
	(bottom-right-images (make-image "border.png"))

	;; example:
	;; (menu-imags (list (make-image "normal") (make-image "normal_active")
	;;           (make-image "hilited_active") (make-image "clicked_active")))
	;;
	;; (title-images (list (set-image-border (make-image "t2-.png") 10 10 0 0)
	;;                     (set-image-border (make-image "t2.png") 10 10 0 0)))

	;; 15x15, 300x15
	(title-images (list
		(make-image "title-normal.png")
	        (set-image-border (make-image "title-focused.png") 100 100 0 0)))

	;; 28x15
	(close-images (list (make-image "close-normal.png")
			    (make-image "close-normal.png")
			    (make-image "close-normal.png")
			    (make-image "close-clicked.png")))

	;; 28x15
	(maximize-images (list (make-image "maximize-normal.png")
			       (make-image "maximize-normal.png")
			       (make-image "maximize-normal.png")
			       (make-image "maximize-clicked.png")))

	;; 28x15
	(iconify-images (list
		(make-image "minimize-normal.png") (make-image "minimize-normal.png")
		(make-image "minimize-normal.png") (make-image "minimize-clicked.png")))

	;; 18x15, these images is used for menu-button temporarily
	(menu-images (list
		(make-image "sticky-normal.png") (make-image "sticky-normal.png") 
		(make-image "sticky-normal.png") (make-image "sticky-clicked.png")))


;; ------------------------- frame definitions ------------------------

  (frame `(
	((background . ,close-images)
	 (top-edge . -15) (left-edge . 0)
	 (class . close-button))
	((background . ,title-images)
	 (left-edge . 28) (right-edge . 74) (top-edge . -15)
	 (foreground . "white") (text . ,window-name)
	 (x-justify . center) (y-justify . center)
	 (class . title))
	((background . ,menu-images)
	 (right-edge . 56) (top-edge . -15)
	 (class . menu-button))
	((background . ,iconify-images)
	 (right-edge . 28) (top-edge . -15)
	 (class . iconify-button))
	((background . ,maximize-images)
	 (right-edge . 0) (top-edge . -15)
	 (class . maximize-button))
	((background . ,left-images)
	 (left-edge . -2) (top-edge . -15) (bottom-edge . 0)
	 (class . left-border))
	((background . ,right-images)
	 (right-edge . -2) (top-edge . -15) (bottom-edge . 0)
	 (class . right-border))
	;((background . ,top-images)
	; (left-edge . 0) (right-edge . 0) (top-edge . -2)
	; (class . top-border))
	((background . ,bottom-images)
	 (left-edge . 0) (right-edge . 0) (bottom-edge . -2)
	 (class . bottom-border))
	((background . ,top-left-images)
	 (left-edge . -2) (top-edge . 0)
	 (class . top-left-corner))
	((background . ,top-right-images)
	 (right-edge . -2) (top-edge . 0)
	 (class . top-right-corner))
	((background . ,bottom-left-images)
	 (left-edge . -2) (bottom-edge . -2)
	 (class . bottom-left-corner))
	((background . ,bottom-right-images)
	 (right-edge . -2) (bottom-edge . -2)
	 (class . bottom-right-corner))))

  (shaped-frame `(
	((background . ,close-images)
	 (top-edge . -15) (left-edge . 0)
	 (class . close-button))
	((background . ,title-images)
	 (left-edge . 28) (right-edge . 74) (top-edge . -15)
	 (foreground . "black") (text . ,window-name)
	 (x-justify . center) (y-justify . center)
	 (class . title))
	((background . ,menu-images)
	 (right-edge . 56) (top-edge . -15)
	 (class . menu-button))
	((background . ,iconify-images)
	 (right-edge . 28) (top-edge . -15)
	 (class . iconify-button))
	((background . ,maximize-images)
	 (right-edge . 0) (top-edge . -15)
	 (class . maximize-button))))

  (transient-frame `(
	((background . ,left-images)
	 (left-edge . -2) (top-edge . -2) (bottom-edge . 0)
	 (class . left-border))
	((background . ,right-images)
	 (right-edge . -2) (top-edge . -2) (bottom-edge . 0)
	 (class . right-border))
	((background . ,top-images)
	 (left-edge . 0) (right-edge . 0) (top-edge . -2)
	 (class . top-border))
	((background . ,bottom-images)
	 (left-edge . 0) (right-edge . 0) (bottom-edge . -2)
	 (class . bottom-border))
	((background . ,top-left-images)
	 (left-edge . -2) (top-edge . 0)
	 (class . top-left-corner))
	((background . ,top-right-images)
	 (right-edge . -2) (top-edge . 0)
	 (class . top-right-corner))
	((background . ,bottom-left-images)
	 (left-edge . -2) (bottom-edge . -2)
	 (class . bottom-left-corner))
	((background . ,bottom-right-images)
	 (right-edge . -2) (bottom-edge . -2)
	 (class . bottom-right-corner)))))


  (add-frame-style 'kde2
	(lambda (w type)
	  (case type
		((default) frame)
		((transient) transient-frame)
		((shaped) shaped-frame)
		((shaped-transient) transient-frame))))
)
